<?php

/***************************************************************************
 *                             activetopics.php
 *                            -------------------
 *   Begin                : Maandag, 21 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Weergeeft de topics binnen een sub-forum
 *
 ***************************************************************************/

include('includes/headers.php');

$paginatitel = 'Active topics';
include('header.php');
				
$dt = new ParseTemplate;
$dt->gettemp('activetopics.tpl', 'activetopics');
									
// Starten met parsen van de topics...
				
function titel_strip($i){ 
	if(strlen($i) > 40){ 
		$k = substr($i, 0, 40); 
		$ls = strrpos($k, ' '); 
		$k = substr($k, 0, $ls);  
		$i =  $k.'...'; 
		return $i; 
	} 
	else{ 
		return $i; 
	} 
}

/* Tsja, deels gelijk aan sub.php :-) */
			
function maak_jumpbox($topic_id, $aantal_replys, $replys_per_page){ 
	$jumpbox = "<select onchange=\"javascript:hupsa('topic.php?id=".$topic_id."&amp;p=', this.options[this.selectedIndex].value)\" name=\"jb".$topic_id."\">\n
				<option value='0'>".$aantal_replys."</option>";
	$aantal_selects = ceil($aantal_replys / $replys_per_page);
	for($i = 0; $i < $aantal_selects; $i++){
		$jumpbox .= "<option value='".$i."'>p. ".($i+1)."</option>"; 
	}									
	$jumpbox .= "</select>";
	return $jumpbox;
}

$sql = "SELECT id
		FROM ".$db['prefix']."subs 
		WHERE modforum = 1";
$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
if(isset($res)){ // De modforums in een array plaatsen
	$modforums_array = mysql_fetch_assoc($res);
}
		
$sql = "SELECT f.id, f.titel, f.views, f.replys, f.poster_id, f.sub_id, f.sticky, f.slot, f.faq, 
				DATE_FORMAT( f.laatstepost, '%d.%m.%y %H:%i' ) AS laatstepost, UNIX_TIMESTAMP( f.laatstepost ) AS laatstepost_stamp, 
				g.id AS laatsteposter_id, g.gebruikersnaam AS topicstarter
		 FROM ".$db['prefix']."topics f
		 LEFT JOIN ".$db['prefix']."gebruikers g ON f.poster_id = g.id 
		 WHERE f.slot != 1 
		 ORDER BY f.laatstepost DESC 
		 LIMIT 0,".$_SESSION['max_topics_in_sub'];
				
$class = 'kleur2';
$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
if(isset($res)){
	while($t = mysql_fetch_assoc($res)){
		
		if( (is_array($modforums_array) && !in_array($t['sub_id'], $modforums_array) ) || !is_array($modforums_array)  ){
			
			// Topics in modforums worden niet weergegeven
							
			if($t['faq'] == 1){
				$topic_map_img = 'sub_faq'; 
				$topic_map_alt = 'FAQ topic'; 
				$tag = '<span class="faq_topic"> [FAQ] ';
				$tag_end = '</span>';
			}
			elseif($t['sticky'] == 1){
				$topic_map_img = 'sub_sticky'; 
				$topic_map_alt = 'Sticky topic'; 
				$tag = '<span class="sticky_topic">';
				$tag_end = '</span>';
			}
			elseif($t['slot'] == 1){
				$topic_map_img = 'sub_slot'; 
				$topic_map_alt = 'Topic gesloten';
				$tag = '';
				$tag_end = '';
			}
			else{ 
				$topic_map_img = ( intval($t['laatstepost_stamp']) > (time() - 600) ) ? 'sub_mapje_rood' : 'sub_mapje';
				$topic_map_alt = ( intval($t['laatstepost_stamp']) > (time() - 600) ) ? 'Actief topic' : 'Topic';
				$tag = '';
				$tag_end = '';
			}
									
			$dt->parse('TOPICS');
			$dt->addvar('TOPICS', 'class', $class);
			$dt->addvar('TOPICS', 'topic_map_img', $topic_map_img);
			$dt->addvar('TOPICS', 'topic_map_alt', $topic_map_alt);
			$dt->addvar('TOPICS', 'topic_id', $t['id']);
			$dt->addvar('TOPICS', 'topic_titel', $tag.htmlspecialchars(titel_strip(stripslashes($t['titel']))).$tag_end);
			$dt->addvar('TOPICS', 'topic_titel_alt', htmlspecialchars(stripslashes($t['titel'])));
			$dt->addvar('TOPICS', 'topic_views', number_format($t['views'], 0, '', '.'));
			$dt->addvar('TOPICS', 'topic_replys', ($t['replys']+1 > $_SESSION['max_posts_in_topic']) ? maak_jumpbox($t['id'], $t['replys']+1, $_SESSION['max_posts_in_topic']) : number_format($t['replys']));
			$dt->addvar('TOPICS', 'topic_laatstepost', $t['laatstepost']);
			$dt->addvar('TOPICS', 'topic_topicstarter_id', $t['poster_id']);
			$dt->addvar('TOPICS', 'topic_topicstarter', $t['topicstarter']);
			$dt->addvar('TOPICS', 'topic_laatsteposter_id', $t['laatsteposter_id']);
								
			$class = ($class == 'kleur2') ? 'kleur3' : 'kleur2';
		}
	}
}			
				
$dt->display('activetopics');	
include('footer.php');

?>