<?

/***************************************************************************
 *                                parse.inc.php
 *                            -------------------
 *   Begin                : Dinsdag, 8 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Template parse file
 *
 ***************************************************************************
 *   This template parser is based on the 'dtemplate' parser by Dufronte
 ***************************************************************************/

if(!defined('IN_CT')){
	die('Hacking attempt');
}

class ParseTemplate{

	var $templates = array(array());
	var $parsed = array(array(array()));
	var $parts = array(array(array()));
	
	/* Masochist: "Oh, sla me!"; Sadist: "Nee!" */
	
	function gettemp($filename,$name_handle){
		$path = 'templates/'.$filename;
		$fp = fopen($path,'r');

		while(!feof($fp)){
			@$this->templates[$name_handle]['content'] .= fgets($fp,4096); // ."\n"
		}
		
		$this->templates[$name_handle]['content'] = str_replace("%7B",'{',$this->templates[$name_handle]['content']);
		$this->templates[$name_handle]['content'] = str_replace("%7D",'}',$this->templates[$name_handle]['content']);

		@$this->check_linked($name_handle);
		@$this->checked_formed($name_handle);

	}

	function check_linked($name_handle){

		$temp = explode("\n", $this->templates[$name_handle]['content']);
		$amount = count($temp);
		for($i=0; $i < $amount; $i++){

			$temp[$i] = trim($temp[$i]);
			if(eregi("^(\{)([A-Za-z0-9._-]+)(\.[A-Za-z]+)(\})$",$temp[$i], $regs)){

				$file = $regs[2].$regs[3];
				$link_handle_name = $regs[2];
				$this->gettemp($file, $link_handle_name);
				$this->templates[$name_handle]['content'] = str_replace('{'.$file.'}', $this->templates[$link_handle_name]['content'], $this->templates[$name_handle]['content']);
			}		
		}
	}

	function checked_formed($name_handle){

		$temp = explode("\n", $this->templates[$name_handle]['content']);
		$amount = count($temp);
		$temp_templates = $this->templates[$name_handle]['content'];
		$this->templates[$name_handle]['content'] = '';

		for($i=0; $i < $amount; $i++){

			$temp[$i]=trim($temp[$i]);
			if(eregi("^(\{)([A-Za-z]+)(:)([A-Za-z0-9._-]+)(\})$", $temp[$i], $regs)){

					$this->templates[$name_handle]['content'] .= $temp[$i]."\n";
					$i++;
					
					while(!eregi('{/'.$regs[2].$regs[3].$regs[4].'}', $temp[$i])){
						$name = $regs[4];
						$i = $this->getchild($name, $temp_templates, $i);
						$this->parts[$name]['content'] .= $temp[$i];
						$temp[$i] = '';
						$i++;
					}
			}

			else{

				$this->templates[$name_handle]['content'] .= $temp[$i]."\n";	
				continue;

			}

			$this->templates[$name_handle]['content'] .= $temp[$i]."\n";	
		}
	}
	
	function getchild($parent, $templates, $i){
		$temp = explode("\n", $templates);
		$temp[$i] = trim($temp[$i]);
		
		if(eregi("^(\{)([A-Za-z]+)(:)([A-Za-z0-9._-]+)(\})",$temp[$i], $child)){
			
			$this->parts[$parent]['content'] .= $temp[$i];
			$i++;
			$child_name = $child[4];
			$this->parts[$child_name]['parent'] = $parent;
			
			while(!eregi('{/'.$child[2].$child[3].$child[4].'}', $temp[$i])){
				
				$i = $this->getchild($child_name, $templates, $i);
				$temp[$i]=trim($temp[$i]);
				$this->parts[$child_name]['content'] .= $temp[$i];
				$temp[$i] =  '';
				$i++;
			}
		}
		return $i;
	}
	
	/* Als je van rookworst de "r" weg haalt, heb je ook worst */
	
	function display($name){

		$this->check_formated($name);
		$this->templates[$name]['content'] = eregi_replace("\{[a-zA-Z0-9]+\}",'', $this->templates[$name]['content']);
		$this->templates[$name]['content'] = eregi_replace("\{[a-zA-Z0-9]+\:[a-zA-Z0-9]+\}",'', $this->templates[$name]['content']);
		$this->templates[$name]['content'] = eregi_replace("\{\/[a-zA-Z0-9]+\:[a-zA-Z0-9]+\}",'', $this->templates[$name]['content']);
		$this->templates[$name]['content'] = eregi_replace("\{[a-zA-Z0-9]+\.[a-zA-Z0-9]+\}",'', $this->templates[$name]['content']);

		print $this->templates[$name]['content'];

	}

	function parse($name, $parent = NULL){
			
			if(!empty($parent)){	
				
				$this->parsed[$parent]['content'] = str_replace('{SUB:'.$name.'}', $this->parts[$name]['content']."\n",$this->parsed[$parent]['content']);
				$this->parsed[$parent]['content'] = str_replace('{/SUB:'.$name.'}',"{SUB:".$name."}\n{/SUB:".$name."}\n", $this->parsed[$parent]['content']);
				
				if(empty($this->parsed[$name]['content'])){
					$this->parsed[$name]['content'] = eregi_replace("\{[a-zA-Z0-9]+\}", '', $this->parts[$name]['content']);
				}
			}
			else{
				
				@$this->parsed[$name]['content'] = eregi_replace("\{[a-zA-Z0-9]+\:[a-zA-Z0-9]+\}",'', $this->parsed[$name]['content']);
				@$this->parsed[$name]['content'] = eregi_replace("\{\/[a-zA-Z0-9]+\:[a-zA-Z0-9]+\}",'', $this->parsed[$name]['content']);
				@$this->parsed[$name]['content'] .= $this->parts[$name]['content'];
			}
	}

	function addvar($handle_name, $variable, $value){

		if(!empty($this->templates[$handle_name]['content'])){ 

			$this->templates[$handle_name]['content'] = str_replace('{'.$variable.'}',$value, $this->templates[$handle_name]['content']);
		}
		elseif(!empty($this->parsed[$handle_name]['content'])){ 

			$this->parsed[$handle_name]['content'] = str_replace('{'.$variable.'}', $value, $this->parsed[$handle_name]['content']);
		}
	}

	function check_formated($name){   

		$temp = explode("\n", $this->templates[$name]['content']);

		$amount = count($temp);

		$this->templates[$name]['content'] = '';

		for($i=0; $i < $amount; $i++){ 

			$temp[$i] = trim($temp[$i]);

			if(eregi("^(\{)([A-Za-z]+)(:)([A-Za-z0-9._-]+)(\})$", $temp[$i], $regs)){

				$handle_name=$regs[4];
				if(!empty($this->parsed[$handle_name]['content']) && !empty($this->parts[$handle_name]['content']) && empty($this->parts[$handle_name]['parent'])){    

						$temp[$i] .= $this->parsed[$handle_name]['content'];	
				}
				else{
					
					continue;
				}

				while(eregi('{/'.$regs[2].$regs[3].$regs[4].'}',$temp[$i])){

					$temp[$i] = '';
				}
			}

			$this->templates[$name]['content'] .= $temp[$i]."\n";
		}
	}

}

?>