<?php

/***************************************************************************
 *                                  beheer.php
 *                            -------------------
 *   Begin                : Woensdag, 23 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Beheer Control Panel (Beheer CP)
 *
 ***************************************************************************/

include('includes/headers.php');

if(isset($_SESSION['userid'])
	&& isset($_SESSION['userlevel']) 
	&& $_SESSION['userlevel'] == 3){ // Alleen toegang voor Beheerders
	
	$paginatitel = 'Beheer CP';
	include('header.php');
	
	$mode = (isset($_GET['mode'])) ? $_GET['mode'] : 'index';
	
	include('templates/beheer/navigatie.tpl');
	
	switch($mode){
	
		case 'index':
								
			$r = array();
			$sql = "SELECT COUNT(1)
					FROM ".$db['prefix']."posts"; // Aantal posts
			$r['aantal_posts'] = mysql_result(mysql_query($sql),0);
			$sql = "SELECT COUNT(1)
					FROM ".$db['prefix']."subs"; // Aantal subforums
			$r['aantal_subs'] = mysql_result(mysql_query($sql),0);
			$sql = "SELECT COUNT(1)
					FROM ".$db['prefix']."catos"; // Aantal catos
			$r['aantal_catos'] = mysql_result(mysql_query($sql),0);
			$sql = "SELECT COUNT(1)
					FROM ".$db['prefix']."topics"; // Aantal topics
			$r['aantal_topics'] = mysql_result(mysql_query($sql),0);
			$sql = "SELECT COUNT(1)
					FROM ".$db['prefix']."gebruikers"; // Aantal gebruikers
			$r['aantal_gebruikers'] = mysql_result(mysql_query($sql),0);
			$sql = "SELECT VERSION()"; // MySQL versie
			$r['mysql_versie'] = mysql_result(mysql_query($sql),0);
			$r['php_versie'] = phpversion(); // PHP versie
			$r['datum'] = date("d-m-Y H:i"); // Datum + tijd
			
			$dt = new ParseTemplate;
			$dt->gettemp('beheer/index.tpl', 'index');
		
			$dt->addvar('index', 'aantal_posts', number_format($r['aantal_posts'], 0, '', '.'));
			$dt->addvar('index', 'aantal_topics', number_format($r['aantal_topics'], 0, '', '.'));
			$dt->addvar('index', 'aantal_subs', $r['aantal_subs']);
			$dt->addvar('index', 'aantal_catos', $r['aantal_catos']);
			$dt->addvar('index', 'aantal_gebruikers', number_format($r['aantal_gebruikers'], 0, '', '.'));
			$dt->addvar('index', 'mysql_versie', $r['mysql_versie']);
			$dt->addvar('index', 'php_versie', $r['php_versie']);
			$dt->addvar('index', 'datum', ucfirst(strftime("%A %e %B %Y")));
			
			// De gebruikers online weergeven
			$sql2 = "SELECT id, gebruikersnaam, userlevel, login_ip, 
							DATE_FORMAT( laatstebezoek, '%d.%m.%y %H:%i' ) AS laatstonline 
					FROM ".$db['prefix']."gebruikers 
					WHERE laatstebezoek > ( NOW() - INTERVAL 5 MINUTE ) 
					ORDER BY laatstebezoek DESC";
			$result2 = mysql_query($sql2) or die(mysql_error()."<hr><pre>".$sql2."</pre>");
			
			if(isset($result2)){
				while($t = mysql_fetch_assoc($result2)){
					
					switch($t['userlevel']){
						case 1: $gebruikersnaam = "<b>".htmlspecialchars(stripslashes($t['gebruikersnaam']))."</b>"; break;
						case 2: $gebruikersnaam = "<span class='moderator'>".htmlspecialchars(stripslashes($t['gebruikersnaam']))."</span>"; break;
						case 3: $gebruikersnaam = "<span class='beheerder'>".htmlspecialchars(stripslashes($t['gebruikersnaam']))."</span>"; break;
						case 4: $gebruikersnaam = "<span class='banned'>".htmlspecialchars(stripslashes($t['gebruikersnaam']))."</span>"; break;
						default: $gebruikersnaam = "<b>".htmlspecialchars(stripslashes($t['gebruikersnaam']))."</b>"; break;
					}
					
					$online_ipadres = (isset($t['login_ip'])) ? $t['login_ip'] : 'Niet opgeslagen';
					
					$dt->parse('ONLINE');
					$dt->addvar('ONLINE', 'online_gebruikersnaam', $gebruikersnaam);
					$dt->addvar('ONLINE', 'online_laatstonline', $t['laatstonline']);
					$dt->addvar('ONLINE', 'online_ipadres', $online_ipadres);
					$dt->addvar('ONLINE', 'online_id', $t['id']);
				}
			}
				
			$dt->display('index');
												
		break;
		case 'forumbeheer':
		
			if(isset($_GET['del_cato'])){
			
				$sql = "SELECT COUNT(1) 
						FROM ".$db['prefix']."subs 
						WHERE cato_id = '".intval($_GET['del_cato'])."'";
				$bevat_subs = mysql_result(mysql_query($sql),0);
				
				if($bevat_subs == 0){
					
					$sql = "SELECT titel  
							FROM ".$db['prefix']."catos 
							WHERE id = '".intval($_GET['del_cato'])."'";
					
					$cato_titel = mysql_result(mysql_query($sql),0);
					
					$sql = "DELETE FROM ".$db['prefix']."catos 
							WHERE id = '".intval($_GET['del_cato'])."'";
					mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
					
					echo message('Categorie verwijderd', "De categorie <b>".htmlspecialchars(stripslashes($cato_titel))."</b> is succesvol verwijderd.");	
	
				}
				else{
					
					echo message('Kan de categorie niet verwijderen', "Deze categorie kan niet verwijderd worden omdat deze nog subforums bevat. Verwijder eerst alle subforums uit deze categorie alvorens deze categorie verwijderd kan worden.");	
				}
				
			}
			elseif(isset($_GET['del_sub'])){
				
				$sql = "SELECT COUNT(1) 
						FROM ".$db['prefix']."topics 
						WHERE sub_id = '".intval($_GET['del_sub'])."'";
				$bevat_topics = mysql_result(mysql_query($sql),0);
				
				if($bevat_topics == 0){
					
					$sql = "SELECT titel  
							FROM ".$db['prefix']."subs 
							WHERE id = '".intval($_GET['del_sub'])."'";
					
					$sub_titel = mysql_result(mysql_query($sql),0);
					
					$sql = "DELETE FROM ".$db['prefix']."subs 
							WHERE id = '".intval($_GET['del_sub'])."'";
					mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
					
					echo message('Subforum verwijderd', "Het subforum <b>".htmlspecialchars(stripslashes($sub_titel))."</b> is succesvol verwijderd.");	
	
				}
				else{
					
					echo message('Kan het subforum niet verwijderen', "Dit subforum kan niet verwijderd worden omdat deze nog topics bevat. Verwijder eerst alle topics uit dit subforum (pruning op 0 dagen) alvorens dit subforum verwijderd kan worden.");	
				}
				
			}
			elseif(isset($_POST['add_cato_titel']) 
					&& strlen(trim($_POST['add_cato_titel'])) > 0){
					
					$sql = "INSERT INTO ".$db['prefix']."catos 
								(id, titel) 
							VALUES 
								('', '".$_POST['add_cato_titel']."')";
					mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
					
					echo message('Categorie aangemaakt', "De categorie <b>".htmlspecialchars(stripslashes($_POST['add_cato_titel']))."</b> is succesvol aangemaakt.");	
			}
			elseif(isset($_POST['add_sub_titel']) 
					&& strlen(trim($_POST['add_sub_titel'])) > 0
					&& isset($_POST['add_sub_cato']) 
					&& strlen(trim($_POST['add_sub_cato'])) > 0 
					&& $_POST['add_sub_cato'] != 0 
					&& isset($_POST['add_sub_subtitel']) 
					&& strlen(trim($_POST['add_sub_subtitel'])) > 0
					&& isset($_POST['add_sub_modforum']) 
					&& strlen(trim($_POST['add_sub_modforum'])) > 0){
					
					$sql = "INSERT INTO ".$db['prefix']."subs 
								(id, titel, cato_id, subtitel, modforum) 
							VALUES 
								('', '".$_POST['add_sub_titel']."', '".$_POST['add_sub_cato']."', '".$_POST['add_sub_subtitel']."', '".$_POST['add_sub_modforum']."')";
					mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
					
					echo message('Subforum aangemaakt', "Het subforum <b>".htmlspecialchars(stripslashes($_POST['add_sub_titel']))."</b> is succesvol aangemaakt.");	
			}
			else{
			
				$dt = new ParseTemplate;
				$dt->gettemp('beheer/forumbeheer.tpl','forumbeheer');
				
				$sub_jump_options = '';
				$sql = "SELECT * 
						FROM ".$db['prefix']."catos 
						ORDER BY titel ASC ";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					$sub_jump_options .= "<option>Selecteer een forum categorie...</option>";
					while($j = mysql_fetch_assoc($res)){
						$sub_jump_options .= "<option value='".$j['id']."'>&raquo; ".htmlspecialchars(stripslashes($j['titel']))."</option>";
					}
				}
				
				$dt->addvar('forumbeheer', 'jumpbox', $sub_jump_options);
				
				$sql = "SELECT * 
						FROM ".$db['prefix']."catos 
						ORDER BY id ASC";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					while($r = mysql_fetch_assoc($res)){
						
						$dt->parse('CATOS');
						$dt->addvar('CATOS', 'cato_id', $r['id']);
						$dt->addvar('CATOS', 'cato_titel', htmlspecialchars(stripslashes($r['titel'])));
						
						$sql2 = "SELECT id, titel, topics, modforum 
						FROM ".$db['prefix']."subs 
						WHERE cato_id = '".$r['id']."'  
						ORDER BY id ASC";
						$res2 = mysql_query($sql2) or die(mysql_error()."<hr><pre>".$sql2."</pre>");
						if(isset($res2)){
							while($t = mysql_fetch_assoc($res2)){
								
								$modforum = ($t['modforum'] == 1) ? '<span class="moderator">Modforum</span>' : '<span class="beheerder">Open forum</span>';
								
								$dt->parse('SUBS', 'CATOS');
								$dt->addvar('CATOS', 'sub_id', $t['id']);
								$dt->addvar('CATOS', 'sub_titel', $t['titel']);
								$dt->addvar('CATOS', 'sub_topics', number_format($t['topics'], 0, '', '.'));
								$dt->addvar('CATOS', 'sub_modforum', $modforum);
								
							}
						}
						
					}
				}				
				
				$dt->display('forumbeheer');		
			}
		
		break;
		case 'pruning':
		
			if(isset($_POST['prune_sub']) && $_POST['prune_sub'] != 0 && isset($_POST['prune_aantal'])){
				
				$sql = "SELECT titel FROM ".$db['prefix']."subs WHERE id = '".intval($_POST['prune_sub'])."'";
				$subforum = mysql_result(mysql_query($sql),0); // Subforum titel opsnorren
				
				$sql = "SELECT COUNT(1) 
						FROM ".$db['prefix']."topics 
						WHERE laatstepost < ( NOW() - INTERVAL ".intval($_POST['prune_aantal'])." DAY ) 
						AND sub_id = '".intval($_POST['prune_sub'])."' 
						AND faq = '0' 
						AND sticky = '0'";
				
				// Aantal te verwijderen topics.
				$aantal_topics = mysql_result(mysql_query($sql),0);
				
				$sql = "DELETE FROM ".$db['prefix']."topics, ".$db['prefix']."posts 
						USING ".$db['prefix']."topics, ".$db['prefix']."posts 
						WHERE ".$db['prefix']."topics.id = ".$db['prefix']."posts.topic_id 
						AND ".$db['prefix']."topics.laatstepost < ( NOW() - INTERVAL ".intval($_POST['prune_aantal'])." DAY ) 
						AND ".$db['prefix']."topics.sub_id = '".intval($_POST['prune_sub'])."' 
						AND ".$db['prefix']."topics.faq = '0' 
						AND ".$db['prefix']."topics.sticky = '0'";
				
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				// Subforum updaten - het aantal verwijderde topics
				$sql = "UPDATE ".$db['prefix']."subs 
						SET topics = topics-".$aantal_topics." 
						WHERE id = '".intval($_POST['prune_sub'])."'";
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				echo message('Pruning voltooid', "De pruning voor het subforum <b>".htmlspecialchars(stripslashes($subforum))."</b> is voltooid. 
				Er zijn in totaal <b>".$aantal_topics."</b> topics verwijderd.");
				
			}
			else{
	
				$sub_jump_options = '';
				$sql = "SELECT id, titel 
						FROM ".$db['prefix']."subs 
						ORDER BY titel ASC ";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					$sub_jump_options .= "<option value='0'>Selecteer een subforum...</option>";
					while($j = mysql_fetch_assoc($res)){
						$sub_jump_options .= "<option value='".$j['id']."'>&raquo; ".htmlspecialchars(stripslashes($j['titel']))."</option>";
					}
				}
				
				$dt = new ParseTemplate;
				$dt->gettemp('beheer/prune.tpl', 'prune');
			
				$dt->addvar('prune', 'jumpbox', $sub_jump_options);
					
				$dt->display('prune');
					
			}
				
		break;
		case 'dboptimaliseren':
		
			if(isset($_GET['start']) && $_GET['start'] == 1){
			
				$sql = "OPTIMIZE TABLE ".$db['prefix']."catos, ".$db['prefix']."gebruikers, ".$db['prefix']."ipban, 
									   ".$db['prefix']."posts, ".$db['prefix']."subs, ".$db['prefix']."topics";
				
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				echo message('DB Optimalisatie voltooid', "De database optimalisatie is succesvol voltooid!");	
			
			}
			else{
				
				echo message('DB Optimaliseren', "De Database Optimalisatie optie voert een OPTIMIZE() functie uit over alle Cool Topix database 
				tabellen. Een optimalisatie behoort eens in de zoveel tijd uitgevoerd te worden om eventuele overhead ruimte binnen de tabellen 
				te verwijderen. Een optimalisatie kan enkele seconden duren (bij grote databases).
				<br />
				<div class='center'>[<b><a href='beheer.php?mode=dboptimaliseren&start=1'>Voer de optimalisatie uit</a></b>]</div>");	
				
			}
		
		break;
		case 'ipban':
		
			if(isset($_POST['ban_ip']) && strlen(trim($_POST['ban_ip'])) > 0){
			
				$sql = "INSERT INTO ".$db['prefix']."ipban 
							(id, ip, datum) 
						VALUES
							('', '".$_POST['ban_ip']."', NOW() )";
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				if(@!gethostbyaddr($_POST['ban_ip']))
					$hostname = 'Onbekend';
				else
					$hostname = gethostbyaddr($_POST['ban_ip']);
					
				echo message('IP adres toegevoegd aan de banlijst', "Het IP adres <b>".htmlspecialchars(stripslashes($_POST['ban_ip']))."</b> <i>(".htmlspecialchars(stripslashes($hostname)).")</i> is succesvol toegevoegd aan de banlijst. Toegang tot dit forum, is voor dit IP adres nu uitgesloten.");	
			
			}
			elseif(isset($_GET['remove_ip'])){
			
				$sql = "DELETE FROM ".$db['prefix']."ipban 
						WHERE id = '".intval($_GET['remove_ip'])."'";
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				echo message('IP adres verwijderd van de banlijst', "Het IP adres is succesvol verwijderd van de banlijst. Toegang tot dit forum, is voor dit IP adres weer toegestaan.");	
			
			}
			else{
			
				$dt = new ParseTemplate;
				$dt->gettemp('beheer/ipban.tpl', 'ipban');			
				
				$sql = "SELECT id, ip, DATE_FORMAT( datum, '%d.%m.%y %H:%i' ) AS datum 
						FROM ".$db['prefix']."ipban 
						ORDER BY datum DESC";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					while($r = mysql_fetch_assoc($res)){
						
						$dt->parse('IPADRES');
						$dt->addvar('IPADRES', 'ip_adres', htmlspecialchars(stripslashes($r['ip'])));
						$dt->addvar('IPADRES', 'id', $r['id']);
						$dt->addvar('IPADRES', 'datum', $r['datum']);
					}
				}
					
				$dt->display('ipban');		
			}
		
		break;
		case 'modbeheer':
		
			if(isset($_POST['add_mod']) && strlen(trim($_POST['add_mod'])) > 0){
			
				/*
				$sql = "SELECT COUNT(1) 
						FROM ".$db['prefix']."gebruikers 
						WHERE gebruikersnaam = '".$_POST['add_mod']."'";
				*/
				$sql = "SELECT userlevel 
						FROM ".$db['prefix']."gebruikers 
						WHERE gebruikersnaam = '".$_POST['add_mod']."'";
				$userlevel_nu = @mysql_result(mysql_query($sql),0);
				
				if(isset($userlevel_nu) && $userlevel_nu != false){
				
					if($userlevel_nu != 3){
						
						$sql = "UPDATE ".$db['prefix']."gebruikers 
								SET userlevel = '2' 
								WHERE gebruikersnaam = '".$_POST['add_mod']."'";
						mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
											
						echo message('Moderator userlevel toegewezen', "<b>".htmlspecialchars(stripslashes($_POST['add_mod']))."</b> heeft de userlevel 'Moderator' succesvol toegekregen. Na de volgende login van deze persoon, zullen zijn/haar moderator rechten in werking gaan.");	
					}
					else{
						echo message('Fout!', "De gebruiker <b>".htmlspecialchars(stripslashes($_POST['add_mod']))."</b> heeft de status 'Beheerder' Wegens veiligheidsredenen is de userlevel 'Beheerder' niet te veranderen.");	
					}
				}
				else{
				
					echo message('Fout!', "De gebruiker <b>".htmlspecialchars(stripslashes($_POST['add_mod']))."</b> bestaat niet op dit forum.");	
				}
			}
			elseif(isset($_GET['remove_mod'])){
			
				$sql = "UPDATE ".$db['prefix']."gebruikers 
						SET userlevel = '1' 
						WHERE id = '".intval($_GET['remove_mod'])."'";
				mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				
				echo message('Moderator gedowngrade', "De gebruiker met ID nummer <b>".intval($_GET['remove_mod'])."</b> heeft weer de status van 'Gebruiker' toegekregen.");	
			
			}
			else{
			
				$dt = new ParseTemplate;
				$dt->gettemp('beheer/modbeheer.tpl', 'modbeheer');			
				
				$sql = "SELECT id, gebruikersnaam, DATE_FORMAT( laatstebezoek, '%d.%m.%y %H:%i' ) AS laatstonline 
						FROM ".$db['prefix']."gebruikers 
						WHERE userlevel = '2'  
						ORDER BY gebruikersnaam ASC";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					while($r = mysql_fetch_assoc($res)){
						
						$dt->parse('MOD');
						$dt->addvar('MOD', 'gebruikersnaam', htmlspecialchars(stripslashes($r['gebruikersnaam'])));
						$dt->addvar('MOD', 'id', $r['id']);
						$dt->addvar('MOD', 'laatstonline', $r['laatstonline']);
					}
				}
					
				$dt->display('modbeheer');		
			}
			
		break;
		case 'configuratie':
		
			if(isset($_POST['gzip']) && strlen(trim($_POST['gzip'])) > 0 
				&& isset($_POST['forum_naam']) && strlen(trim($_POST['forum_naam'])) > 0 
				&& isset($_POST['max_topics_in_sub']) && strlen(trim($_POST['max_topics_in_sub'])) > 0 
				&& isset($_POST['max_posts_in_topic']) && strlen(trim($_POST['max_posts_in_topic'])) > 0 
				&& isset($_POST['forum_aan']) && strlen(trim($_POST['forum_aan'])) > 0 
				&& isset($_POST['forum_url']) && strlen(trim($_POST['forum_url'])) > 0 
				&& isset($_POST['flood_interval']) && strlen(trim($_POST['flood_interval'])) > 0 
				&& isset($_POST['session_tijd']) && strlen(trim($_POST['session_tijd'])) > 0 
				&& isset($_POST['email_sig']) && strlen(trim($_POST['email_sig'])) > 0){
			
				foreach($_POST as $key => $value){
					$sql = "UPDATE ".$db['prefix']."config 
							SET config_waarde = '".$value."' 
							WHERE config_titel = '".$key."'";
					mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				}
				
				echo message('Forum configuratie opgeslagen', 'De wijzigingen in de forum configuratie zijn opgeslagen. De configuratie instellingen worden door elke bezoeker binnen een session onthouden tijdens het forumbezoek. Deze session, met de instellingen, word voor elke bezoeker geupdate bij een nieuw bezoek aan het forum.');	
			}
			else{
			
				$sql = "SELECT * FROM ".$db['prefix']."config";
				$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
				if(isset($res)){
					while($r = mysql_fetch_assoc($res)){
						$configuratie[$r['config_titel']] = $r['config_waarde'];	
					}
				}
				
				$dt = new ParseTemplate;
				$dt->gettemp('beheer/configuratie.tpl', 'configuratie');
				
				if($configuratie['gzip'] == 1){
					$gzip_aan = 'selected';
					$gzip_uit = '';
				}
				else{
					$gzip_aan = '';
					$gzip_uit = 'selected';
				}
				
				$dt->addvar('configuratie', 'gzip_aan', $gzip_aan);
				$dt->addvar('configuratie', 'gzip_uit', $gzip_uit);
				
				if($configuratie['forum_aan'] == 1){
					$forum_aan = 'selected';
					$forum_uit = '';
				}
				else{
					$forum_aan = '';
					$forum_uit = 'selected';
				}
				
				$dt->addvar('configuratie', 'forum_aan', $forum_aan);
				$dt->addvar('configuratie', 'forum_uit', $forum_uit);
				
				$dt->addvar('configuratie', 'forum_naam', htmlspecialchars($configuratie['forum_naam']));
				$dt->addvar('configuratie', 'max_posts_in_topic', htmlspecialchars($configuratie['max_posts_in_topic']));
				$dt->addvar('configuratie', 'max_topics_in_sub', htmlspecialchars($configuratie['max_topics_in_sub']));
				$dt->addvar('configuratie', 'email_sig', htmlspecialchars($configuratie['email_sig']));
				
				$dt->addvar('configuratie', 'forum_url', htmlspecialchars($configuratie['forum_url']));
				$dt->addvar('configuratie', 'flood_interval', htmlspecialchars($configuratie['flood_interval']));
				$dt->addvar('configuratie', 'session_tijd', htmlspecialchars($configuratie['session_tijd']));
						
				$dt->display('configuratie');
			}
		
		break;
	}
	
	include('footer.php');
}
else{ // Opzouten!
	header("location: login.php");
}

?>