<?php

/***************************************************************************
 *                               headers.inc.php
 *                            -------------------
 *   Begin                : Dinsdag, 8 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Overall headers bestand
 *
 ***************************************************************************/

if(!defined('HEADERS_SET')){

	error_reporting(E_ALL); // Dat word dus netjes proggen :-)
		
	function ParseTime(){
		list($usec,$sec) = explode(' ', microtime());
		return(floatval($usec)+floatval($sec));
	}
	$start_parse = ParseTime();
	
	define('IN_CT', true);
	
	session_start();
	
	if(file_exists('install.php')) // Checken op install bestand
		die("<font face='verdana' size='2'><b>Ohjee!</b></font><br /><p><font face='verdana' size='2'>Het 'install.php' bestand bestaat nog! Dit is het installatiebestand om Cool Topix te installeren. Voordat je van Cool Topix gebruik kunt maken, dien je 'install.php' eerst te verwijderen van de server.</p></font><ul><li><font face='verdana' size='2'><a href='install.php'>De installatie nog niet uitgevoerd? Klik hier om te installeren!</a></font></li><li><font face='verdana' size='2'>De installatie al wel uitgevoerd? Verwijder dan eerst het 'install.php' bestand, voordat je van Cool Topix gebruik kunt maken.</font></li></ul>");
	
	if(!include_once('./config.inc.php')) // Configuratiebestand
		die('Error: Het config.inc.php bestand kon niet worden gevonden');
	
	if(!include_once('./includes/parse.inc.php')) // Templateparser bestand
		die('Error: Het parse.inc.php bestand kon niet worden gevonden');
	
	if(!include_once('./includes/mysql.inc.php')) // MySQL database bestand
		die('Error: Het mysql.inc.php bestand kon niet worden gevonden');
	
	function message($titel, $bericht){
		$return = "<div class='message_top'> ".$titel." </div>\n<div class='message_text'> ".$bericht." </div>";
		return $return;
	}
	
	// Sommige proxy's zijn fake
	$ipadres = (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];

	if( empty($_SESSION['gzip']) // Zomaar een uit de lijst, willekeurig :-)
	|| ( isset($_SESSION['session_tijd']) 
		&& isset($_SESSION['session_start']) // Oh, de session is verlopen!
		&& $_SESSION['session_start'] < ( time() - $_SESSION['session_tijd'] ))
	){ // Opnieuw...
	
		$sql = "SELECT config_titel, config_waarde 
				FROM ".$db['prefix']."config";
		$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
		if(isset($res)){
			while($r = mysql_fetch_assoc($res)){
				$_SESSION[$r['config_titel']] = $r['config_waarde'];
			}
			$_SESSION['ip'] = $ipadres;			
			
		}
	}
	
	if( $_SESSION['forum_aan'] == 0 && 
		( empty($_SESSION['userlevel']) || $_SESSION['userlevel'] != 3 )  ){
		include('templates/forum_uit.tpl'); // Forum is gesloten :-)
		exit;
	}
	
	if($_SESSION['gzip'] == 1){ // De GZip
		@ob_start("ob_gzhandler"); 
	}
		
	$setlocale = (eregi('microsoft', strtolower($_SERVER['SERVER_SOFTWARE']))) ? 'nld_nld' : 'nl_NL';
	setlocale(LC_ALL, $setlocale);
	
	/*
		De volgende IF statements zijn naar een voorbeeld van phpBB, waarbij ze voorheen nog
		gebruik maakte van $HTTP_IETS_VARS i.p.v. $_IETS. Changed and used :-)
	*/	
	if( !get_magic_quotes_gpc() ){
		if( is_array($_GET) ){
			while( list($k, $v) = each($_GET) ){
				if( is_array($_GET[$k]) ){
					while( list($k2, $v2) = each($_GET[$k]) ){
						$_GET[$k][$k2] = addslashes($v2);
					}
					@reset($_GET[$k]);
				}
				else{
					$_GET[$k] = addslashes($v);
				}
			}
			@reset($_GET);
		}
		if( is_array($_POST) ){
			while( list($k, $v) = each($_POST) ){
				if( is_array($_POST[$k]) ){
					while( list($k2, $v2) = each($_POST[$k]) ){
						$_POST[$k][$k2] = addslashes($v2);
					}
					@reset($_POST[$k]);
				}
				else{
					$_POST[$k] = addslashes($v);
				}
			}
			@reset($_POST);
		}
		if( is_array($_COOKIE) ){
			while( list($k, $v) = each($_COOKIE) ){
				if( is_array($_COOKIE[$k]) ){
					while( list($k2, $v2) = each($_COOKIE[$k]) ){
						$_COOKIE[$k][$k2] = addslashes($v2);
					}
					@reset($_COOKIE[$k]);
				}
				else{
					$_COOKIE[$k] = addslashes($v);
				}
			}
			@reset($_COOKIE);
		}
	}
		
	// IP ban check
	$sql = "SELECT COUNT(1) 
			FROM ".$db['prefix']."ipban 
			WHERE ip = '".$ipadres."'";
	if( mysql_result(mysql_query($sql),0) != 0 )
		die('Error: Dit IP adres is gebanned van dit forum!');
		
	if( empty($_SESSION['userid'])
		&& isset($_COOKIE[md5($_SESSION['forum_url']).'_ct_userid']) 
		&& isset($_COOKIE[md5($_SESSION['forum_url']).'_ct_hash']) ){
		// Hey! Eerste pageview en het login identificatie is onthouden!
				
		$sql = "SELECT id, userlevel, UNIX_TIMESTAMP( laatstebezoek ) AS laatstebezoek  
				FROM ".$db['prefix']."gebruikers 
				WHERE id = '".$_COOKIE[md5($_SESSION['forum_url']).'_ct_userid']."' 
				AND identificatie = '".$_COOKIE[md5($_SESSION['forum_url']).'_ct_hash']."' 
				AND login_ip = '".$ipadres."' 
				LIMIT 0,1";
			
		$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
		if(isset($res)){
			while($r = mysql_fetch_assoc($res)){
				// Sessions bakken
				$_SESSION['userid'] = $r['id'];
				$_SESSION['userlevel'] = $r['userlevel'];
				
				if(empty($_SESSION['user_last_visit'])){
					$_SESSION['user_last_visit'] = $r['laatstebezoek'];
				}
				
				$_SESSION['session_start'] = time();
			}
		}
	}
	elseif(isset($_SESSION['userid'])){
		
		// Laatste pageview updaten
		$sql = "UPDATE ".$db['prefix']."gebruikers
				SET laatstebezoek = NOW() - 1 
				WHERE id = '".$_SESSION['userid']."'";
		
		mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
		
		// Checken of de gebruiker niet ondertussen is gebanned
		$sql = "SELECT userlevel 
				FROM ".$db['prefix']."gebruikers 
				WHERE id = '".$_SESSION['userid']."' 
				LIMIT 0,1";
		
		if( mysql_result(mysql_query($sql),0) == 4 ){
			die("<b>Geen toegang:</b> Dit profiel is gebanned!");
		}
		
		// Dit voorkomt session hijacking
		if( $_SESSION['ip'] != $ipadres )
			die("Session Hijacking error! Geen toegang:<hr>".gethostbyaddr($ipadres));	
		
	}	
		
	/* Ik vraag me af, waarom kan Goofy praten, maar Pluto niet? */
	
	define('HEADERS_SET', true);
}

?>
