<?php

/***************************************************************************
 *                                install.php
 *                            -------------------
 *   Begin                : Woensdag, 25 Augustus, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Installatie bestand
 *
 ***************************************************************************/

error_reporting(E_ALL);

if(!empty($_POST)){
 	
	if( !get_magic_quotes_gpc() ){
		if( is_array($_POST) ){
			while( list($k, $v) = each($_POST) ){
				if( is_array($_POST[$k]) ){
					while( list($k2, $v2) = each($_POST[$k]) ){
						$_POST[$k][$k2] = addslashes($v2);
					}
					@reset($_POST[$k]);
				}
				else{
					$_POST[$k] = addslashes($v);
				}
			}
			@reset($_POST);
		}
	}
	
	foreach($_POST as $name => $value){ // -DELIMITER- mag niet voorkomen wegens SQL injections
		$_POST[$name] = str_replace('-DELIMITER-', 'DELIMITER', $value);
	} 
	
	function split_querys($sql, $delimiter){
		$tekens = explode($delimiter, $sql);
	
		$sql = '';
		$output = array();
		$matches = array();
		
		$teken_count = count($tekens);
		for($i = 0; $i < $teken_count; $i++){
		
			if(($i != ($teken_count - 1)) || (strlen($tekens[$i] > 0))){
				
				$total_quotes = preg_match_all("/'/", $tekens[$i], $matches);
				$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tekens[$i], $matches);
				
				$unescaped_quotes = $total_quotes - $escaped_quotes;
				
				if(($unescaped_quotes % 2) == 0){
					$output[] = $tekens[$i];
					$tekens[$i] = '';
				}
				else{
					$temp = $tekens[$i] . $delimiter;
					$tekens[$i] = '';
					
					$complete_stmt = false;
					
					for($j = $i + 1; (!$complete_stmt && ($j < $teken_count)); $j++){					
						$total_quotes = preg_match_all("/'/", $tekens[$j], $matches);
						$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tekens[$j], $matches);
				
						$unescaped_quotes = $total_quotes - $escaped_quotes;
						
						if(($unescaped_quotes % 2) == 1){
							$output[] = $temp . $tekens[$j];
	
							$tekens[$j] = '';
							$temp = '';
							
							$complete_stmt = true;
							$i = $j;
						}
						else{
							$temp .= $tekens[$j] . $delimiter;
							$tekens[$j] = '';
						}
					}
				}
			}
		}
		return $output;
	}

?>

<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.1//EN' 'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd'>

<html>

<head>

	<title>Cool Topix :: Installatie</title>
	
	<link rel='stylesheet' type='text/css' href='templates/style.css' />
	
</head>
<body>

<div id='maintable'> 
  <p> <img class='noborder' src='templates/img/header_01.jpg' alt='' /> </p>
  <div class='message_top'> <a href='javascript:void(NULL);'>Installatie</a> </div>
  <div class='message_text'> 
    <table width='100%'>
      <?php
	
	// mysql_connect();
	if(!$mysql_connect = @mysql_connect($_POST['mysql_host'], $_POST['mysql_user'], $_POST['mysql_pass'])){
		echo "<tr>
				<td class='kleur2'>Verbinden met de MySQL database:</td>
				<td><span class='moderator'>FOUT!</span> De MySQL database gegevens zijn ongeldig</td>
			  </tr>
			  <tr>
				<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
			  </tr>";
		exit;
	}
	else{
		echo "<tr>
				<td class='kleur2'>Verbinden met de MySQL database:</td>
				<td><span class='beheerder'>OK!</span></td>
			  </tr>";
	}
	
	// mysql_select_db();
	if(!@mysql_select_db($_POST['mysql_name'], $mysql_connect)){
		echo "<tr>
				<td class='kleur2'>MySQL database selecteren:</td>
				<td><span class='moderator'>FOUT!</span> De MySQL database gegevens (MySQL name) zijn ongeldig</td>
			  </tr>
			  <tr>
				<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
			  </tr>";
		exit;
	}
	else{
		echo "<tr>
				<td class='kleur2'>MySQL database selecteren:</td>
				<td><span class='beheerder'>OK!</span></td>
			  </tr>";
	}
	
	// config.inc.php schrijven:
	@umask(0111);
	if( is_writable('config.inc.php') ){
		
		echo "<tr>
				<td class='kleur2'>config.inc.php checken:</td>
				<td><span class='beheerder'>OK!</span></td>
			  </tr>";
		
		if(! ($fp = @fopen('config.inc.php', "w") ) ){
			echo "<tr>
					<td class='kleur2'>config.inc.php schrijven:</td>
					<td><span class='moderator'>FOUT!</span> Het bestand '<b>config.inc.php</b>' kon niet worden geopend!</td>
				  </tr>
				  <tr>
					<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
				  </tr>";
			exit;
		}
		else{
			
			$prefix = str_replace('.', '_', $_POST['mysql_prefix']);
			
			$config_data = '<?php'."\n\n";
			$config_data .= "\n// Cool Topix automatich gegenereerd config bestand\n// Verander niets in dit bestand!\n\n";
			$config_data .= '$db[\'host\'] = \''.$_POST['mysql_host'].'\';'."\n\n";
			$config_data .= '$db[\'name\'] = \''.$_POST['mysql_name'].'\';'."\n";
			$config_data .= '$db[\'user\'] = \''.$_POST['mysql_user'].'\';'."\n";
			$config_data .= '$db[\'pass\'] = \''.$_POST['mysql_pass'].'\';'."\n";
			$config_data .= '$db[\'prefix\'] = \''.$prefix.'\';'. "\n\n";
			$config_data .= "\n// Zelfontplooiing is wellicht ook goed voor je rimpels!\n\n";
			$config_data .= '?'.'>';
			
			if( @fputs($fp, $config_data, strlen($config_data)) ){
				echo "<tr>
						<td class='kleur2'>config.inc.php schrijven:</td>
						<td><span class='beheerder'>OK!</span></td>
			  		  </tr>";
			}
			else{
				echo "<tr>
						<td class='kleur2'>config.inc.php schrijven (#2):</td>
						<td><span class='moderator'>FOUT!</span> Het bestand '<b>config.inc.php</b>' kon niet worden geopend!</td>
				  	</tr>
				  	<tr>
						<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
				  	</tr>";
				exit;
			}
			
			@fclose($fp);		
			
		}
	}
	else{
		echo "<tr>
				<td class='kleur2'>config.inc.php checken:</td>
				<td><span class='moderator'>FOUT!</span> Het bestand '<b>config.inc.php</b>' is onschrijfbaar!</td>
				</tr>
			  <tr>
				<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
			  </tr>";
		exit;
	}
		
// MySQL query's...
$sql = "
	
CREATE TABLE ".$prefix."catos (
  id int(11) NOT NULL auto_increment,
  titel varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."config (
  id int(11) NOT NULL auto_increment,
  config_titel varchar(255) default NULL,
  config_waarde varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."gebruikers (
  id int(11) NOT NULL auto_increment,
  gebruikersnaam varchar(255) default NULL,
  wachtwoord varchar(255) default NULL,
  identificatie varchar(255) default NULL,
  actief int(5) default '0', 
  login_ip varchar(16) default NULL,
  email varchar(255) default NULL,
  laatstebezoek datetime default NULL,
  regdatum date default NULL,
  userlevel smallint(1) default '1',
  aantal_posts int(11) default '0',
  avatar varchar(255) default NULL,
  icq varchar(255) default NULL,
  website varchar(255) default NULL,
  plaats varchar(255) default NULL,
  msn varchar(255) default NULL,
  interesses varchar(255) default NULL,
  sig varchar(255) default NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."ipban (
  id int(11) NOT NULL auto_increment,
  ip varchar(16) NOT NULL default '',
  datum datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."posts (
  id int(11) NOT NULL auto_increment,
  topic_id int(11) default NULL,
  poster_id int(11) default NULL,
  datum datetime default NULL,
  ipadres varchar(15) default NULL,
  editcount smallint(5) NOT NULL default '0',
  text text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."subs (
  id int(11) NOT NULL auto_increment,
  titel varchar(255) NOT NULL default '',
  cato_id int(11) default NULL,
  topics int(11) NOT NULL default '0',
  laatstepost datetime default NULL,
  laatsteposter int(11) NOT NULL default '0',
  subtitel text NOT NULL,
  modforum int(1) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

CREATE TABLE ".$prefix."topics (
  id int(11) NOT NULL auto_increment,
  titel varchar(255) NOT NULL default '',
  poster_id int(11) default NULL,
  datum datetime default NULL,
  sub_id int(11) default NULL,
  slot smallint(1) NOT NULL default '0',
  sticky smallint(1) NOT NULL default '0',
  faq int(1) NOT NULL default '0',
  views int(11) NOT NULL default '0',
  replys int(11) NOT NULL default '0',
  laatstepost datetime default NULL,
  note varchar(255) NOT NULL default '',
  PRIMARY KEY  (id) 
) TYPE=MyISAM AUTO_INCREMENT=1

-DELIMITER-

INSERT INTO ".$prefix."catos (id, titel) 
	VALUES ('', 'Test categorie')

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES	('', 'forum_naam', '".$_POST['forum_titel']."')

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde)
	VALUES 	('', 'max_topics_in_sub', 50)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES	('', 'max_posts_in_topic', 20)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES 	('', 'max_posts_in_topic', 20)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde)
	VALUES	('', 'gzip', 0)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES 	('', 'forum_aan', 1)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde)
	VALUES 	('', 'email_sig', 'Groeten, ".$_POST['forum_titel']."')

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES 	('', 'forum_url', '".$_POST['url']."')

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde) 
	VALUES 	('', 'flood_interval', 15)

-DELIMITER-

INSERT INTO ".$prefix."config 
			(id, config_titel, config_waarde)
	VALUES 	('', 'session_tijd', 300)

-DELIMITER-

INSERT INTO ".$prefix."gebruikers 
			(id, gebruikersnaam, wachtwoord, email, regdatum, userlevel, actief, aantal_posts) 
	VALUES 	('', '".$_POST['beheerder_gebruikersnaam']."', '".md5($_POST['beheerder_wachtwoord'])."', '".$_POST['beheerder_email']."', NOW(), '3', '1', '1')

-DELIMITER-

INSERT INTO ".$prefix."posts 
			(id, topic_id, poster_id, datum, ipadres, text) 
	VALUES 	('', 1, 1, NOW(), '".$_SERVER['REMOTE_ADDR']."', 'Welkom bij Cool Topix,\r\n\r\nGefeliciteerd, je Cool Topix forum is volledig genstalleerd!\r\nZodra je via je beheerders profiel inlogt, verschijnt er een link naar je \'[b]Beheer CP[/b]\' in de navigatiebalk. Van daaruit kun je je splinternieuwe Cool Topix forum configureren en beheren.\r\n\r\nVeel plezier! :goed\r\n\r\n--\r\n[i]Dit topic is automatisch aangemaakt tijdens de installatie van dit forum.[/i]')

-DELIMITER-

INSERT INTO ".$prefix."subs 
			(id, titel, cato_id, topics, laatstepost, laatsteposter, subtitel) 
	VALUES 	('', 'Test subforum', 1, 1, NOW(), 1, 'Dit is het eerste subforum, automatisch gegenereerd tijdens de installatie van Cool Topix. Veel plezier!')

-DELIMITER-

INSERT INTO ".$prefix."topics
			(id, titel, poster_id, datum, sub_id, laatstepost) 
	VALUES 	('', 'Test topic!', 1, NOW(), 1, NOW())

-DELIMITER-
";
	
$sql = trim($sql);
$delimiter = "-DELIMITER-";

$enkele_query = split_querys($sql, $delimiter);
$query_done = array();

for($i = 0; $i < sizeof($enkele_query); $i++){
	if(trim($enkele_query[$i]) != ''){
	
		if(!@mysql_query($enkele_query[$i])){
			$query_done[$i] = 0;
		}
		else{
			$query_done[$i] = 1;
		}
	}
}

if(in_array(0, $query_done)){
	echo "<tr>
		<td class='kleur2'>MySQL database query's:</td>
		<td><span class='moderator'>FOUT!</span> Er is een fout opgetreden bij het uitvoeren van de MySQL query's</td>
	 	</tr>
		<tr>
		<td class='kleur2' colspan='2'>De installatie is afgebroken. [<a href='install.php'>Terug naar installatie</a>]</td>
	 	</tr>";
	exit;
}
else{
	echo "<tr>
		<td class='kleur2'>MySQL database query's:</td>
		<td><span class='beheerder'>OK!</span></td>
		</tr>";
}
				
?>
      <tr> 
        <td colspan='2'><b>De installatie is succesvol voltooid!</b><br />
          Verwijder nu het 'install.php' bestand, voordat het forum gebruikt kan 
          worden. Wegens veiligheidsredenen is het verstandig de schrijfrechten 
          weer te ontnemen van het 'config.inc.php' bestand.<br /> <br />
          [<a href='login.php'>Klik hier om in te loggen op het forum '<?php echo htmlspecialchars(stripslashes($_POST['forum_titel'])); ?>'!</a>]</td>
      </tr>
    </table>
  </div>
  <br />
</div>
</body>
</html>

<?php

}
else{
	
	// Thanks 2 phpBB
	if(!empty($_SERVER['SERVER_NAME']) || !empty($_ENV['SERVER_NAME']))
		$server_name = (!empty($_SERVER['SERVER_NAME'])) ? $_SERVER['SERVER_NAME'] : $_ENV['SERVER_NAME'];
	elseif(!empty($_SERVER['HTTP_HOST']) || !empty($_ENV['HTTP_HOST']))
		$server_name = (!empty($_SERVER['HTTP_HOST'])) ? $_SERVER['HTTP_HOST'] : $_ENV['HTTP_HOST'];
	else
		$server_name = '';
	
	$script_path = str_replace('install.php', '', dirname($_SERVER['PHP_SELF']));
	
	$slash = (substr($script_path, -1) == '/') ? '' : '/';
	
	$forum_url = $server_name.$script_path.$slash;

?>

<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.1//EN' 'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd'>

<html>

<head>

	<title>Cool Topix :: Installatie</title>
	
	<link rel='stylesheet' type='text/css' href='templates/style.css' />
	
</head>
<body>
	
	<script language='JavaScript'>
	<!--
	function check_submit(){
		if( document.reg.mysql_name.value == '' ){ 
			alert("Er is geen waarde opgegeven voor: 'MySQL Name'"); return false;
		}
		if( document.reg.mysql_host.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'MySQL Host'"); return false;
		}
		if( document.reg.mysql_user.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'MySQL User'"); return false;
		}
		if( document.reg.mysql_pass.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'MySQL Password'"); return false;
		}
		if( document.reg.mysql_prefix.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'MySQL Prefix'"); return false;
		}
		if( document.reg.url.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'URL'"); return false;
		}
		if( document.reg.beheerder_gebruikersnaam.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'Beheerder gebruikersnaam'"); return false;
		}
		if( document.reg.beheerder_wachtwoord.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'Beheerder wachtwoord'"); return false;
		}
		if( document.reg.beheerder_wachtwoord_check.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'Beheerder wachtwoord (nogmaals)'"); return false;
		}
		if( document.reg.beheerder_email.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'Beheerder e-mail adres'"); return false;
		}
		if( document.reg.forum_titel.value == '' ){
			alert("Er is geen waarde opgegeven voor: 'Forum titel'"); return false;
		}
		if( document.reg.beheerder_wachtwoord.value != document.reg.beheerder_wachtwoord_check.value ){
			alert("De opgegeven beheerders wachtwoorden komen niet met elkaar overeen!'"); return false;
		}
		return submit();
	}
	-->
	</script>
	
	<form name='reg' method='post' action='install.php' OnSubmit='return check_submit()'>
	
	
  <div id='maintable'> 
    <p> <img class='noborder' src='templates/img/header_01.jpg' alt='' /> </p>
    <div class='message_top'> <a href='javascript:void(NULL);'>Installatie</a> 
    </div>
    <div class='message_text'> Welkom bij de installatie procedure van Cool Topix. 
      Binnen enkele minuten heb je je eigen Cool Topix forum draaiende! Vul de 
      onderstaande gegevens volledig in, en klik op 'Nu installeren' om de installatie 
      te starten. </div>
    <br />
    <div class='message_top'> <a href='javascript:void(NULL);'>MySQL Database 
      gegevens</a> </div>
    <div class='message_text'> 
      <table width='100%'>
        <tr> 
          <td colspan='4'>&para; De gegevens van de MySQL database zijn nodig 
            om de database tabellen te installeren en in te richten.</td>
        </tr>
        <tr> 
          <td class='kleur2' width='200px'>MySQL database name:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='mysql_name' /></td>
          <td class='kleur2' width='200px'>MySQL host:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='mysql_host' value='localhost' /></td>
        </tr>
        <tr> 
          <td class='kleur2' width='200px'>MySQL user:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='mysql_user' /></td>
          <td class='kleur2' width='200px'>MySQL password:</td>
          <td class='kleur3'><input type='password' class='invulveld' name='mysql_pass' /></td>
        </tr>
        <tr> 
          <td class='kleur2' colspan='4'>De tabel prefix is het (herkennings)gedeelte 
            dat voorafgaande aan de database tabellen geplaatst zal worden in 
            de database. Op deze manier zijn alle Cool Topix tabellen simpel te 
            herkennen. Geen idee waar we het over hebben? Laat dan de prefix zoals 
            het is :-)</td>
        </tr>
        <tr> 
          <td class='kleur2' width='200px'>MySQL tabelprefix:</td>
          <td class='kleur3' colspan='3'><input type='text' class='invulveld' name='mysql_prefix' value='ct_' /></td>
        </tr>
      </table>
    </div>
    <br />
    <div class='message_top'> <a href='javascript:void(NULL);'>Server gegevens</a> 
    </div>
    <div class='message_text'> 
      <table width='100%'>
        <tr> 
          <td class='kleur2' width='200px'>Forum URL (zonder http://):</td>
          <td colspan='3' class='kleur3'><input type='text' class='invulveld' name='url' value="<?php echo $forum_url; ?>" size="50"/></td>
        </tr>
        <tr> 
          <td class='kleur2' colspan='4'>Let op: Het bestand '<b>config.inc.php</b>' 
            dient schrijfbaar te zijn. Zorg ervoor dat dit bestand schrijfrechten 
            toe staat tijdens de installatie. Na de installatie kunnen de schrijfrechten 
            weer van het bestand worden ontnomen.</td>
        </tr>
      </table>
    </div>
    <br />
    <div class='message_top'> <a href='javascript:void(NULL);'>Persoonlijke gegevens</a> 
    </div>
    <div class='message_text'> 
      <table width='100%'>
        <tr> 
          <td colspan='4'>&para; Tijdens de installatie word het beheerdersprofiel 
            aangemaakt met de onderstaande gegevens.</td>
        </tr>
        <tr> 
          <td class='kleur2' width='200px'>Beheerder gebruikersnaam:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='beheerder_gebruikersnaam' /></td>
          <td class='kleur2' width='200px'>Beheerder wachtwoord:</td>
          <td class='kleur3'><input type='password' class='invulveld' name='beheerder_wachtwoord' /></td>
        </tr>
        <tr> 
          <td class='kleur2' width='200px'>Beheerder e-mail adres:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='beheerder_email' /></td>
          <td class='kleur2' width='200px'>Wachtwoord (nogmaals):</td>
          <td class='kleur3'><input type='password' class='invulveld' name='beheerder_wachtwoord_check' /></td>
        </tr>
      </table>
    </div>
    <br />
    <div class='message_top'> <a href='javascript:void(NULL);'>Forum gegevens</a> 
    </div>
    <div class='message_text'> 
      <table width='100%'>
        <tr> 
          <td class='kleur2' width='200px'>Forum titel:</td>
          <td class='kleur3'><input type='text' class='invulveld' name='forum_titel' style='width: 490px;' /></td>
        </tr>
      </table>
    </div>
    <br />
    <div class='message_top'> <a href='javascript:void(NULL);'>Nu installeren</a> 
    </div>
    <div class='message_text'> 
      <table width='100%'>
        <tr> 
          <td class='kleur2' colspan='4'><input type='submit' name='submit' value=' Nu installeren! ' /></td>
        </tr>
      </table>
    </div>
  </div>
	
	</form>

</body>
</html>

<?php

}

?>
