<?php

require_once("../include/include.inc.php");

$inhoud = $core->pad.'include/tpl/artikelen.tpl';

require_once($core->pad."include/header.inc.php");

if(!isset($_GET['cid']) || !$_GET['cid']) {
	$s_cats = mysqli_query($conn,"Select c.id, c.titel, c.beschrijving, c.aantal From categorieen As c Where c.soort = 'artikelen' Order By c.titel Asc") or die(mysqli_error($conn));
	$core->sql_count++;
	
	if(!mysqli_num_rows($s_cats)) {
		$tpl->newBlock("tabel");
		$tpl->newBlock("geen_categorieen");

		$tpl->assign("tabel.titel", "Artikelen");
	}
	else {
		$tpl->newBlock("tabel");
		$tpl->newBlock("categorieen_weergeven");
		
		$tpl->assign("tabel.titel", "Artikelen");

		while($f_cat = mysqli_fetch_object($s_cats)) {
			$tpl->newBlock("categorie");
			
			if($f_cat->aantal == 1)
				$f_cat->aantal = '1 artikel';
			else
				$f_cat->aantal = $f_cat->aantal.' artikelen';

			$tpl->assign(array("titel"        => htmlspecialchars(stripslashes($f_cat->titel)),
							   "beschrijving" => parsen(stripslashes($f_cat->beschrijving))	,
							   "aantal"       => $f_cat->aantal					,
							   "cid"          => $f_cat->id                     ,
				));
		}
	}

	if($core->status == "Beheerder") {
		$tpl->newBlock("tabel");
		$tpl->newBlock("admin");

		$s_ongekeurd = mysqli_query($conn,"Select count(id) From artikelen Where gekeurd = 'nee' Order By titel Asc") or die(mysqli_error($conn));
		$core->sql_count++;

		$tpl->assign(array("tabel.titel" => "Artikelen Beheren"          ,
						   "aantal"      => mysql_result($s_ongekeurd, 0),
			));
	}
}
else {
	$s_cat = mysqli_query($conn,"Select titel From categorieen Where soort = 'artikelen' And id = '".$_GET['cid']."'") or die(mysqli_error($conn));
	$core->sql_count++;
	
	if(!mysqli_num_rows($s_cat)) {
		$tpl->newBlock("tabel");
		$tpl->newblock("cat_bestaat_niet");
		$tpl->assign("tabel.titel", "Categorie bestaat niet!");
	}
	else {
		$s_artikelen = mysqli_query($conn,"Select a.id, a.titel, a.auteur, a.datum, l.id As lid, l.status From artikelen As a, leden As l Where cat_id = '".$_GET['cid']."' And l.gebruikersnaam = a.auteur And a.gekeurd = 'ja' Order By a.titel Asc") or die(mysqli_error($conn));
		$core->sql_count++;
		
		$f_cat = mysqli_fetch_object($s_cat);

		$tpl->newBlock("tabel");
		$tpl->newBlock("artikelen_weergeven");

		$tpl->assign(array("tabel.titel" => htmlspecialchars(stripslashes($f_cat->titel)),
						   "c_titel"     => htmlspecialchars(stripslashes($f_cat->titel)),
			));

		if(!mysqli_num_rows($s_artikelen)) {
			$tpl->newBlock("geen_artikelen");
		}
		else {
			while($f_artikel = mysqli_fetch_object($s_artikelen)) {
				$tpl->newBlock("artikel");
				$tpl->assign(array("aid"    => $f_artikel->id,
								   "titel"  => htmlspecialchars(stripslashes($f_artikel->titel)),
								   "auteur" => status($f_artikel->auteur, $f_artikel->status)   ,
								   "datum"  => date("d-m-Y H:i", $f_artikel->datum)             ,
								   "lid"    => $f_artikel->lid                                  ,
					));
			}
		}
	}
}

require_once($core->pad."include/output.inc.php");

?>