<?php

## De template instellen
$tpl = new Templatepower($core->pad.'thema/'.$core->template.'/layout.tpl');

## De include assignen
$tpl->assignInclude("inhoud", $inhoud);
$tpl->assignInclude("formulier", $core->pad."include/tpl/formulier.tpl");
$tpl->assignInclude('reacties', $core->pad.'include/tpl/reactie.tpl');
$tpl->assignInclude('waarderen', $core->pad.'include/tpl/waarderen.tpl');

$tpl->prepare();

$s_leden = mysqli_query($conn,"Select count(id) From leden Where actief = 'ja'") or die(mysqli_error($conn));
$core->sql_count++;
$core->aantal_leden = (mysql_result($s_leden, 0) == 1) ? '1 Lid' : mysql_result($s_leden, 0).' Leden';
mysqli_free_result($s_leden);

## Het linkpartners systeem
$s_linkpartners = mysqli_query($conn,"Select id, titel, kliks From linkpartners Order By titel Asc") or die(mysqli_error($conn));
$core->sql_count++;

if(!mysqli_num_rows($s_linkpartners))
	$tpl->newBlock("geen_linkpartners");
else {
	while($f_linkpartner = mysqli_fetch_object($s_linkpartners)) {
		$tpl->newBlock("linkpartners_index");
		$tpl->assign(array("id"	    => $f_linkpartner->id                                   ,
						   "titel"  => stripslashes(htmlspecialchars($f_linkpartner->titel)),
						   "aantal" => $f_linkpartner->kliks								,
			));
	}
}

mysqli_free_result($s_linkpartners);

## Menu aanpassen
if($core->ingelogd) {
	$core->sql_count++;
	$tpl->newBlock("index_ingelogd");
	$tpl->assign("aantal", $core->priveberichten);
}
else {
	$tpl->newBlock("index_nietingelogd");
}

## Het online systeem
$s_online = mysqli_query($conn,"Select o.gebruikersnaam, o.type, l.anoniemsurf, l.status, l.id From online As o Left Join leden As l On l.gebruikersnaam = o.gebruikersnaam Order By l.gebruikersnaam Asc") or die(mysqli_error($conn));
$core->sql_count++;

$o_gasten  = 0;
$o_leden   = 0;
$gebr      = array();
$i         = 0;
$gebruiker = array();

while($f_online = mysqli_fetch_object($s_online)) {
	$i++;
	
	if(isset($gebruiker[$f_online->gebruikersnaam]) && $gebruiker[$f_online->gebruikersnaam] && $f_online->gebruikersnaam) {
		mysqli_query($conn,"Delete From online Where gebruikersnaam = '".$f_online->gebruikersnaam."'") or die(mysqli_error($conn));
		mysqli_query($conn,"Insert Into online (id, gebruikersnaam, ip, tijd, type) Values ('NULL', '".$f_online->gebruikersnaam."', '', '".time()."', 'lid')") or die(mysqli_error($conn));
		$core->sql_count = $core->sql_count + 2;
	}

	## Dubbel aanwezig check
	$gebruiker[$f_online->gebruikersnaam] = 1;

	if($f_online->gebruikersnaam && $f_online->anoniemsurf == "nee") {
		if($f_online->status == "Beheerder" || $f_online->status == "Super Moderator" || $f_online->status == "Moderator") {
			$gebr[$i] = '<a href="'.$core->url.'leden/profiel.php?id='.$f_online->id.'" class="zwart"><b>'.status($f_online->gebruikersnaam, $f_online->status).'</b></a>';
		}
		else {
			$gebr[$i] = '<a href="'.$core->url.'leden/profiel.php?id='.$f_online->id.'" class="zwart">'.status($f_online->gebruikersnaam, $f_online->status).'</a>';
		}
	}

	if($f_online->type == "lid")
		$o_leden++;
	else
		$o_gasten++;

}

if($o_gasten == 1)
	$gasten = '<b>1</b> gast';
else
	$gasten = '<b>'.$o_gasten.'</b> gasten';

if($o_leden == 1)
	$leden = 'zijn momenteel <b>1</b> lid';
else
	$leden = 'zijn momenteel <b>'.$o_leden.'</b> leden';

$online_str = '('.$o_leden.') ';
if(empty($gebr))
	$online_str .= '<b>Geen</b> of anonieme leden';
else
	$online_str .= implode(', ', $gebr);
$online_str .= ' en '. $gasten;

$tpl->assignGlobal("bez_online", "Er ".$leden." en ".$gasten." actief op Webfanaat.");

mysqli_free_result($s_online);

## De admin opties toevoegen
if($core->status == "Beheerder") {
	@$tpl->newBlock("beheer_site");
}

## Het menu

/*if(isset($_COOKIE['menu']) && $_COOKIE['menu']) {
	$menu_content = explode(",", $_COOKIE['menu']);
	$menu = $menu_content;
	$cookie_str = '';

	for($i = 0; $i < count($menu_content); $i++) {
		
		$menu[$i] = explode(":", $menu_content[$i]);

		if($menu[$i][1] == 0) {
			$show[$i] = 'none';
			$img[$i] = 'plus';
		}
		else {
			$show[$i] = 'yes';
			$img[$i] = 'min';
		}
		
		$i2 = $i + 1;

		if($i2 == 5) {
			$tpl->assign("beheer_site.menu_".$i2, $show[$i]);
			$tpl->assign("beheer_site.img_menu_".$i2, $img[$i].".gif");
		}
		else {
			$tpl->assign("_ROOT.menu_".$i2, $show[$i]);
			$tpl->assign("_ROOT.img_menu_".$i2, $img[$i].".gif");
		}

		$cookie_str .=  $i2.':'.$menu[$i][1].',';
	}

	$cookie_str = substr($cookie_str, 0, -1);
}
else {
	$cookie_str = '';

	for($i = 1; $i <= $core->menus; $i++) {
		$cookie_str .= $i.':1,';
		$tpl->assign("menu_".$i, "yes");
		$tpl->assign("_ROOT.img_menu_".$i, "min.gif");
	}

	$cookie_str = substr($cookie_str, 0, -1);

	setcookie("menu", $cookie_str, time() + 999999999, "/");
}*/

$tpl->assign("_ROOT.img_menu_1", "min.gif");
$tpl->assign("_ROOT.img_menu_2", "min.gif");
$tpl->assign("_ROOT.img_menu_3", "min.gif");
$tpl->assign("_ROOT.img_menu_4", "min.gif");
$tpl->assign("_ROOT.img_menu_5", "min.gif");
$tpl->assign("_ROOT.img_menu_6", "min.gif");
$tpl->assign("_ROOT.img_menu_7", "min.gif");


## Een aantal basisvariabelen voor de Template instellen
$tpl->assignGlobal("url", $core->url);
$tpl->assignGlobal("websitenaam", $core->websitenaam);
$tpl->assignGlobal("websiteslogan", $core->websiteslogan);
$tpl->assignGlobal("email_afzender", $core->email_afzender);
$tpl->assignGlobal("naam_afzender", $core->naam_afzender);
$tpl->assignGlobal("versie", $core->versie);
$tpl->assignGlobal("PHP_SELF", $_SERVER['PHP_SELF']);
$tpl->assignGlobal("thema", $core->template);
$tpl->assign("_ROOT.aantal_leden", $core->aantal_leden);
$tpl->assignGlobal("gebruikersnaam", $core->gebruikersnaam);
$tpl->assignGlobal("tabel_alt_kleur", $core->tabel_alt_kleur);
$tpl->assignGlobal("tabel_alt_kleur2", $core->tabel_alt_kleur2);
$tpl->assignGlobal("rollover", $core->rollover);
$tpl->assignGlobal("hr_kleur", $core->hr_kleur);

unset($s_leden);

?>