<?php

## Error reporting
error_reporting(E_ALL);

## Tijd limiet voor scripts op oneindig zetten, uit i.v.m. Safe mode
##set_time_limit(0);

## Output Cachen
ob_start("ob_gzhandler");

## De juiste tijdzone instellen
//putenv("TZ=Europe/Amsterdam");

$core=new \stdClass();

## Volledig pad en url instellen
$core->pad = '/hier/je/pad/public_html/';
$core->url = 'https://website-url.nl/';

## Extra toegevoegd in de Webfanaat-SE versie variable voor oa de mails
$core->websitenaam = 'Webfanaat-SE';
$core->websiteslogan = 'Webfanaat-SE';
$core->email-afzender = 'noreply@website-url.nl';
$core->naam-afzender = 'Webfanaat-SE';

## Enkele variabelen instellen
$core->sql_count		= 0;
$core->ingelogd			= '';
$core->gebruikersnaam	= '';
$core->status			= '';
$core->smilies			= 20;
$core->menus			= 7;
$core->r_soorten		= 'artikelen,nieuws,downloads,links,scripts,poll';
$core->avatarszien		= 'ja';
$core->mem_id			= '';
$core->gestemd			= '';
$core->offline			= '';

## De redirect urls voor na het reageren
$redir['artikelen'] = $core->url.'artikelen/artikelen.php?id=';
$redir['nieuws']    = $core->url.'index.php?nieuws=';
$redir['downloads'] = $core->url.'downloads/downloads.php?id=';
$redir['links']     = $core->url.'links/links.php?id=';
$redir['scripts']   = $core->url.'scripts/scripts.php?id=';
$redir['poll']      = $core->url.'poll/index.php?id=';

## De versie van Webfanaat
$core->versie = 'versie 4.0.2-2025';

## de laadtijd van de pagina berekenen
function laadtijd($deel) {
        global $starttijd;

        ## starttijd
        if($deel == 1) {
                $starttijd = explode(' ', microtime());
                $starttijd = $starttijd[0] + $starttijd[1];

                return $starttijd;
        }

        ## eindtijd
        elseif($deel == 2) {
                $eindtijd = explode(' ', microtime());
                $eindtijd = round((($eindtijd[0] + $eindtijd[1]) - $starttijd), 5);

                return $eindtijd;
        }
}

/***** ***** ***** ***** ***** ***** ***** ***** ***** *****

mysql_result omzetten naar mysqli_data_seek

***** ***** ***** ***** ***** ***** ***** ***** ***** *****/
if (!function_exists('mysql_result')) {
    function mysql_result($result, $number, $field=0) {
        mysqli_data_seek($result, $number);
        $row = mysqli_fetch_array($result);
        return $row[$field];
    }
}

$starttijd = laadtijd(1);

require_once($core->pad.'include/downpage.inc.php');

## Connectie met de database include
require_once($core->pad.'include/mysql.inc.php');

## Het reactiesysteem includen
require_once($core->pad.'reactie/reactie.inc.php');

## Het waarderingssysteem includen
require_once($core->pad.'reactie/waarderen.inc.php');


$_COOKIE['gebruikersnaam'] = (!isset($_COOKIE['gebruikersnaam']) || !$_COOKIE['gebruikersnaam']) ? '' : $_COOKIE['gebruikersnaam'];

$s_lid = mysqli_query($conn,"Select l.id, l.mailopenbaar, l.email, l.av_extentie, l.gestemd, l.notificatie, l.gebruikersnaam, l.ip, l.status, l.avatarszien, Count(p.id) As priveberichten, Count(b.id) As gebanned From leden As l Left Join priveberichten As p On l.gebruikersnaam = p.naar And gelezen = 'nee' Left Join ban As b On l.gebruikersnaam = b.gebruikersnaam Where l.sleutel='".$_COOKIE['gebruikersnaam']."' Group By l.id") or die(mysqli_error($conn));
$core->sql_count++;

if($_COOKIE['gebruikersnaam'] && mysqli_num_rows($s_lid)) {
        $f_lid = mysqli_fetch_object($s_lid);

        $core->gebruikersnaam = $f_lid->gebruikersnaam;
        $core->email                  = $f_lid->email;
        $core->status                  = $f_lid->status;
        $core->ingelogd                  = 1;
        $core->mem_id                  = $f_lid->id;
        $core->avatarszien          = $f_lid->avatarszien;
        $core->f_notificatie  = $f_lid->notificatie;
        $core->gestemd        = $f_lid->gestemd;
        $core->mailopenbaar   = $f_lid->mailopenbaar;
        $core->priveberichten = $f_lid->priveberichten;
        $core->gebanned                  = $f_lid->gebanned;
        $core->ip                          = $f_lid->ip;
        $core->av_extentie          = $f_lid->av_extentie;

        mysqli_free_result($s_lid);
}
else {
        $s_ban = mysqli_query($conn,"Select ip From ban") or die(mysqli_error($conn));
        $core->sql_count++;

        $ip = array();

        while($f_ban = mysqli_fetch_object($s_ban)) {
                $ip[] = $f_ban->ip;
        }

        if(in_array($_SERVER['REMOTE_ADDR'], $ip))
                $core->gebanned = 1;
        else
                $core->gebanned = 0;

        $core->ingelogd = 0;
}

## Een sleutel genereren
function sleutel() {
        $sleutel = '';
        $i = 0;
        $keys = 'ABCDEFGHIJKMLNOPQRSTUVWXYZ1234567890';

        @mt_srand((double) @microtime() * 1000000);

        for (@$key = @strlen(@$keys); @$i < 8; @$i++)
                @$sleutel .= @$keys[@mt_rand(0, @$key)];

        return $sleutel;
}

$core->template = 'blauw';

## De template engine, de parser en de formulier functie includen + template instellingen
require_once($core->pad."thema/".$core->template."/instellingen.inc.php");
require_once($core->pad.'include/template.inc.php');
require_once($core->pad.'include/parser.inc.php');

## Is de site offline?
$s_offline = mysqli_query($conn,"Select id, reden From offline") or die(mysqli_error($conn));
$core->sql_count++;

if(mysqli_num_rows($s_offline)) {
        $core->offline = 1;
        $f_offline = mysqli_fetch_object($s_offline);
}

if(mysqli_num_rows($s_offline) && $core->status != "Beheerder") {
        $off = new Downpage;
        $off->pagina('Webfanaat is tijdelijk offline', parsen(stripslashes($f_offline->reden)));
        exit;
}

mysqli_free_result($s_offline);

if(date("i") == "30" || date("i") == "00" || date("i") == "15" || date("i") == "45") {
        mysqli_query($conn,"Delete From leden Where tijd < ".time()." - 60*60*48 And actief != 'ja'") or die(mysqli_error($conn));
        $core->sql_count++;
        mysqli_query($conn,"Delete From priveberichten Where tijd < ".time()." - 60*60*24*31") or die(mysqli_error($conn));
        $core->sql_count++;
        mysqli_query($conn,"Delete From sleutels Where tijd < ".time()." - 600*5") or die(mysqli_error($conn));
        $core->sql_count++;
}

## Functie voor het parsen van een text
function parsen($art)
{
        return @end(parse($art));
}

function ondertitel($ondertitel, $posts) {

        if(!$ondertitel) {
                if($posts <= 100)
                        return("Nieuw Lid");
                elseif($posts >= 101 && $posts <= 250)
                        return("Normaal Lid");
                elseif($posts >= 251 && $posts<= 400)
                        return("Goed Lid");
                elseif($posts >= 401 && $posts <= 900)
                        return("Goeroe Lid");
                elseif($posts > 900)
                        return("Webfanaat");
        }
        else
                return($ondertitel);
}

## Functie om de status een kleurtje te geven
function status($gebruikersnaam, $status) {
        if($status == "Beheerder")
                return("<font color=\"red\">".$gebruikersnaam."</font>");
        elseif($status == "Moderator")
                return("<font color=\"blue\">".$gebruikersnaam."</font>");
        elseif($status == "Super Moderator")
                return("<font color=\"navy\">".$gebruikersnaam."</font>");
        elseif($status == "Verbannen")
                return("<font color=\"darkgreen\">".$gebruikersnaam."</font>");
        else
                return("<font color=\"black\">".$gebruikersnaam."</font>");
}

## Functie om nesting te replacen
function ReplaceNesting($message) {

        $message = preg_replace("/\[li\](.*)\[\/li\]/", "- \\1", $message);
        $message = str_replace("/[li]/", "- ", $message);
        $message = preg_replace("/\[quote\](.*)\[\/quote\]/", "[..]\n\n", $message);
        $message = preg_replace("/\[code\](.*)\[\/code\]/", "[..]\n\n", $message);
        $message = preg_replace("/\[img\](.*)\[\/img\]/", "[..]\n\n", $message);
        $message = preg_replace("/\[img=(.*)\]/", "[..]\n\n", $message);

        return $message;
}

## Functie om te kijken of het aantal gebruikte smilies niet te groot is
function CheckSmilies($message) {
        global $smilie_find, $core;

        $message = preg_replace("/\[code\](.*)\[\/code\]/", "", $message);

        $a = 0;
        for($i = 0; $i < count($smilie_find); $i++) {

                ## De hoeveelheid smilies tellen
                $a += substr_count($message,$smilie_find[$i]);
        }

        if($a > $core->smilies)
                return 0;
        else
                return 1;
}

## Het hoeveel mensen zijn er online systeem
mysqli_query($conn,"Delete From online Where tijd < ".time()." - 60*5") or die(mysqli_error($conn));
$core->sql_count++;

$o_url = substr($_SERVER['REQUEST_URI'], 1);

if($core->ingelogd) {
        $s_online = mysqli_query($conn,"Select count(id) From online Where gebruikersnaam = '".$core->gebruikersnaam."'") or die(mysqli_error($conn));
        $core->sql_count++;

        if(!mysql_result($s_online, 0)) {
                mysqli_query($conn,"Insert Into online (id, gebruikersnaam, tijd, type, url, ip) Values (NULL, '".$core->gebruikersnaam."', '".time()."', 'lid', '".$o_url."', '".$_SERVER['REMOTE_ADDR']."')") or die(mysqli_error($conn));
                $core->sql_count++;
        }
        else {
                mysqli_query($conn,"Update online Set tijd = '".time()."', url = '".$o_url."' Where gebruikersnaam = '".$core->gebruikersnaam."'") or die(mysqli_error($conn));
                $core->sql_count++;
        }
}
else {
        $s_online = mysqli_query($conn,"Select count(id) From online Where ip = '".$_SERVER['REMOTE_ADDR']."'") or die(mysqli_error($conn));
        $core->sql_count++;

        if(!mysql_result($s_online, 0)) {
                mysqli_query($conn,"Insert Into online (id, ip, tijd, type, url) Values (NULL, '".$_SERVER['REMOTE_ADDR']."', '".time()."', 'gast', '".$o_url."')") or die(mysqli_error($conn));
                $core->sql_count++;
        }
        else {
                mysqli_query($conn,"Update online Set tijd = '".time()."', url = '".$o_url."' Where ip = '".$_SERVER['REMOTE_ADDR']."'") or die(mysqli_error($conn));
                $core->sql_count++;
        }
}

mysqli_free_result($s_online);

## Unieke Bezoekersteller
$s_datum = mysqli_query($conn,"Select count(id) From unieke_bezoekers Where datum = '".date("d-m-Y")."'") or die(mysqli_error($conn));
$core->sql_count++;

if(!mysql_result($s_datum, 0)) {
        ## Toevoegen + 1 bezoeker
        mysqli_query($conn,"Delete From unieke_bezoekers_data") or die(mysqli_error($conn));
        mysqli_query($conn,"Insert Into unieke_bezoekers (id, datum, bezoekers) Values (NULL, '".date("d-m-Y")."', '1')") or die(mysqli_error($conn));
        mysqli_query($conn,"Insert Into hits (id, datum, hits) Values (NULL, '".date("d-m-Y")."', '1')") or die(mysqli_error($conn));
        mysqli_query($conn,"Insert Into unieke_bezoekers_data (id, ip) Values (NULL, '".$_SERVER['REMOTE_ADDR']."')") or die(mysqli_error($conn));
        $core->sql_count = $core->sql_count + 4;
}
else {
        ## Checken voor bestaan en dan niks of toevoegen
        $s_data = mysqli_query($conn,"Select count(id) From unieke_bezoekers_data Where ip = '".$_SERVER['REMOTE_ADDR']."'") or die(mysqli_error($conn));
        $core->sql_count++;

        mysqli_query($conn,"Update hits Set hits = hits + 1 Where datum = '".date("d-m-Y")."'") or die(mysqli_error($conn));
        $core->sql_count++;

        if(!mysql_result($s_data, 0)) {
                mysqli_query($conn,"Update unieke_bezoekers Set bezoekers = bezoekers + 1 Where datum = '".date("d-m-Y")."'") or die(mysqli_error($conn));
                mysqli_query($conn,"Insert Into unieke_bezoekers_data (id, ip) Values (NULL, '".$_SERVER['REMOTE_ADDR']."')") or die(mysqli_error($conn));
                $core->sql_count = $core->sql_count + 2;
        }

        mysqli_free_result($s_data);
}

## Het bansysteem
if($core->gebanned) {
        $off = new Downpage;
        $off->pagina('Verbannen', "Je bent verbannen van Webfanaat.");
        exit;
}

## Het referer log systeem
if(getenv("HTTP_REFERER")) {
        $ref = explode("/", getenv("HTTP_REFERER"));

        if(!in_array("webfanaat-se.nl", $ref) && !in_array("www.webfanaat-se.nl", $ref)) {
                $s_refs = mysqli_query($conn,"Select Count(id) From refs Where url = '".$_SERVER['HTTP_REFERER']."'") or die(mysqli_error($conn));
                $core->sql_count++;
		
                if(!mysql_result($s_refs, 0)) {
                        mysqli_query($conn,"Insert Into refs (id, url, aantal) Values (NULL, '".$_SERVER['HTTP_REFERER']."', '1')") or die(mysqli_error($conn));
                        $core->sql_count++;
                }
                else {
                        mysqli_query($conn,"Update refs Set aantal = aantal + 1 Where url = '".$_SERVER['HTTP_REFERER']."'") or die(mysqli_error($conn));
                        $core->sql_count++;
                }

                mysqli_free_result($s_refs);
        }
}

?>